#ifndef TWN_GL_ANY_RENDERING_H
#define TWN_GL_ANY_RENDERING_H

/*
 * Any OpenGL version base render methods.
 */

#ifdef EMSCRIPTEN
#include <GLES2/gl2.h>
#else
#include <glad/glad.h>
#endif

#include <stdbool.h>


#define QUAD_ELEMENT_BUFFER_LENGTH (65536 / 6)

typedef GLuint vertex_buffer;

typedef struct vertex_buffer_builder {
    size_t bytes_left;
    void *mapping;
} vertex_buffer_builder;


vertex_buffer create_vertex_buffer(void);

void delete_vertex_buffer(vertex_buffer buffer);

void specify_vertex_buffer(vertex_buffer buffer, void *data, size_t bytes);

void setup_viewport(int x, int y, int width, int height);

void bind_quad_element_buffer(void);

void clear_draw_buffer(void);

void swap_buffers(void);

void set_depth_range(double low, double high);

#endif
